Get data streams Generally available; Added in 7.9.0

GET /_data_stream

Get information about one or more data streams.

Required authorization

  • Index privileges: view_index_metadata

Query parameters

  • expand_wildcards string | array[string]

    Type of data stream that wildcard patterns can match. Supports comma-separated values, such as open,hidden.

    Values are all, open, closed, hidden, or none.

  • include_defaults boolean Generally available; Added in 8.11.0

    If true, returns all relevant default configurations for the index template.

  • master_timeout string

    Period to wait for a connection to the master node. If no response is received before the timeout expires, the request fails and returns an error.

    Values are -1 or 0.

    External documentation
  • verbose boolean

    Whether the maximum timestamp for each data stream should be calculated and returned.

Responses

  • 200 application/json
    Hide response attribute Show response attribute object
    • data_streams array[object] Required
      Hide data_streams attributes Show data_streams attributes object
      • _meta object

        Custom metadata for the stream, copied from the _meta object of the stream’s matching index template. If empty, the response omits this property.

        Hide _meta attribute Show _meta attribute object
        • * object Additional properties
      • allow_custom_routing boolean

        If true, the data stream allows custom routing on write request.

      • failure_store object

        Information about failure store backing indices

        Hide failure_store attributes Show failure_store attributes object
        • enabled boolean Required
        • indices array[object] Required
        • rollover_on_write boolean Required
      • generation number Required

        Current generation for the data stream. This number acts as a cumulative count of the stream’s rollovers, starting at 1.

      • hidden boolean Required

        If true, the data stream is hidden.

      • ilm_policy string

        Name of the current ILM lifecycle policy in the stream’s matching index template. This lifecycle policy is set in the index.lifecycle.name setting. If the template does not include a lifecycle policy, this property is not included in the response. NOTE: A data stream’s backing indices may be assigned different lifecycle policies. To retrieve the lifecycle policy for individual backing indices, use the get index settings API.

      • next_generation_managed_by string Required

        Name of the lifecycle system that'll manage the next generation of the data stream.

        Values are Index Lifecycle Management, Data stream lifecycle, or Unmanaged.

      • prefer_ilm boolean Required

        Indicates if ILM should take precedence over DSL in case both are configured to managed this data stream.

      • indices array[object] Required

        Array of objects containing information about the data stream’s backing indices. The last item in this array contains information about the stream’s current write index.

        Hide indices attributes Show indices attributes object
        • index_name string Required

          Name of the backing index.

        • index_uuid string Required

          Universally unique identifier (UUID) for the index.

        • ilm_policy string

          Name of the current ILM lifecycle policy configured for this backing index.

        • managed_by string

          Name of the lifecycle system that's currently managing this backing index.

          Values are Index Lifecycle Management, Data stream lifecycle, or Unmanaged.

        • prefer_ilm boolean

          Indicates if ILM should take precedence over DSL in case both are configured to manage this index.

        • index_mode string

          The index mode of this backing index of the data stream.

          Values are standard, time_series, logsdb, or lookup.

      • lifecycle object Generally available; Added in 8.11.0

        Contains the configuration for the data stream lifecycle of this data stream.

        Hide lifecycle attributes Show lifecycle attributes object
        • downsampling array[object]

          The list of downsampling rounds to execute as part of this downsampling configuration

        • enabled boolean

          If defined, it turns data stream lifecycle on/off (true/false) for this data stream. A data stream lifecycle that's disabled (enabled: false) will have no effect on the data stream.

          Default value is true.

      • name string Required

        Name of the data stream.

      • replicated boolean

        If true, the data stream is created and managed by cross-cluster replication and the local cluster can not write into this data stream or change its mappings.

      • rollover_on_write boolean Required

        If true, the next write to this data stream will trigger a rollover first and the document will be indexed in the new backing index. If the rollover fails the indexing request will fail too.

      • settings object Required

        The settings specific to this data stream that will take precedence over the settings in the matching index template.

        Hide settings attributes Show settings attributes object
        • index object
        • mode string
        • routing_path string | array[string]

        • soft_deletes object
        • sort object
        • number_of_shards number | string Generally available

          One of:

          Default value is 1.

          Default value is 1.

        • number_of_replicas number | string Generally available

          One of:

          Default value is 0.

          Default value is 0.

        • number_of_routing_shards number
        • check_on_startup string

          Values are true, false, or checksum.

        • codec string

          Default value is LZ4.

        • routing_partition_size
        • load_fixed_bitset_filters_eagerly boolean

          Default value is true.

        • hidden boolean | string

          One of:

          Default value is false.

          Default value is false.

        • auto_expand_replicas string | null

          One of:

          Default value is false.

          A null value that is to be interpreted as an actual value, unless other uses of null that are equivalent to a missing value. It is used for exemple in settings, where using the NullValue for a setting will reset it to its default value.

        • merge object
        • refresh_interval string

          A duration. Units can be nanos, micros, ms (milliseconds), s (seconds), m (minutes), h (hours) and d (days). Also accepts "0" without a unit and "-1" to indicate an unspecified value.

        • max_result_window number

          Default value is 10000.0.

        • max_inner_result_window number

          Default value is 100.0.

        • max_rescore_window number

          Default value is 10000.0.

        • max_script_fields number

          Default value is 32.0.

        • max_ngram_diff number

          Default value is 1.0.

        • max_shingle_diff number

          Default value is 3.0.

        • blocks object
        • max_refresh_listeners number
        • analyze object

          Settings to define analyzers, tokenizers, token filters and character filters. Refer to the linked documentation for step-by-step examples of updating analyzers on existing indices.

        • highlight object
        • max_terms_count number

          Default value is 65536.0.

        • max_regex_length number

          Default value is 1000.0.

        • routing object
        • gc_deletes string

          A duration. Units can be nanos, micros, ms (milliseconds), s (seconds), m (minutes), h (hours) and d (days). Also accepts "0" without a unit and "-1" to indicate an unspecified value.

        • default_pipeline string
        • final_pipeline string
        • lifecycle object
        • provided_name string
        • creation_date
        • creation_date_string
        • uuid string
        • version object
        • verified_before_close boolean | string

        • format string | number

        • max_slices_per_scroll number
        • translog object
        • query_string object
        • priority number | string

        • top_metrics_max_size number
        • analysis object
        • settings object
        • time_series object
        • queries object
        • similarity object

          Configure custom similarity settings to customize how search results are scored.

        • mapping object

          Enable or disable dynamic mapping for an index.

        • indexing.slowlog object
        • indexing_pressure object

          Configure indexing back pressure limits.

        • store object

          The store module allows you to control how index data is stored and accessed on disk.

      • mappings object

        The mappings specific to this data stream that will take precedence over the mappings in the matching index template.

        Hide mappings attributes Show mappings attributes object
        • all_field object
        • date_detection boolean
        • dynamic string

          Values are strict, runtime, true, or false.

        • dynamic_date_formats array[string]
        • dynamic_templates array[object]
        • _field_names object
        • index_field object
        • _meta object
        • numeric_detection boolean
        • properties object
        • _routing object
        • _size object
        • _source object
        • runtime object
          Hide runtime attribute Show runtime attribute object
          • * object Additional properties
        • enabled boolean
        • subobjects string

          Values are true or false.

        • _data_stream_timestamp object
      • status string Required

        Health status of the data stream. This health status is based on the state of the primary and replica shards of the stream’s backing indices.

        Values are green, GREEN, yellow, YELLOW, red, RED, unknown, or unavailable.

      • system boolean Generally available; Added in 7.10.0

        If true, the data stream is created and managed by an Elastic stack component and cannot be modified through normal user interaction.

      • template string Required

        Name of the index template used to create the data stream’s backing indices. The template’s index pattern must match the name of this data stream.

      • timestamp_field object Required

        Information about the @timestamp field in the data stream.

        Hide timestamp_field attribute Show timestamp_field attribute object
        • name string Required

          Name of the timestamp field for the data stream, which must be @timestamp. The @timestamp field must be included in every document indexed to the data stream.

      • index_mode string

        The index mode for the data stream that will be used for newly created backing indices.

        Values are standard, time_series, logsdb, or lookup.

GET /_data_stream
curl \
 --request GET 'http://api.example.com/_data_stream'
Response examples (200)
A successful response for retrieving information about a data stream.
{
  "data_streams": [
    {
      "name": "my-data-stream",
      "timestamp_field": {
        "name": "@timestamp"
      },
      "indices": [
        {
          "index_name": ".ds-my-data-stream-2099.03.07-000001",
          "index_uuid": "xCEhwsp8Tey0-FLNFYVwSg",
          "prefer_ilm": true,
          "ilm_policy": "my-lifecycle-policy",
          "managed_by": "Index Lifecycle Management"
        },
        {
          "index_name": ".ds-my-data-stream-2099.03.08-000002",
          "index_uuid": "PA_JquKGSiKcAKBA8DJ5gw",
          "prefer_ilm": true,
          "ilm_policy": "my-lifecycle-policy",
          "managed_by": "Index Lifecycle Management"
        }
      ],
      "generation": 2,
      "_meta": {
        "my-meta-field": "foo"
      },
      "status": "GREEN",
      "next_generation_managed_by": "Index Lifecycle Management",
      "prefer_ilm": true,
      "template": "my-index-template",
      "ilm_policy": "my-lifecycle-policy",
      "hidden": false,
      "system": false,
      "allow_custom_routing": false,
      "replicated": false,
      "rollover_on_write": false
    },
    {
      "name": "my-data-stream-two",
      "timestamp_field": {
        "name": "@timestamp"
      },
      "indices": [
        {
          "index_name": ".ds-my-data-stream-two-2099.03.08-000001",
          "index_uuid": "3liBu2SYS5axasRt6fUIpA",
          "prefer_ilm": true,
          "ilm_policy": "my-lifecycle-policy",
          "managed_by": "Index Lifecycle Management"
        }
      ],
      "generation": 1,
      "_meta": {
        "my-meta-field": "foo"
      },
      "status": "YELLOW",
      "next_generation_managed_by": "Index Lifecycle Management",
      "prefer_ilm": true,
      "template": "my-index-template",
      "ilm_policy": "my-lifecycle-policy",
      "hidden": false,
      "system": false,
      "allow_custom_routing": false,
      "replicated": false,
      "rollover_on_write": false
    }
  ]
}